apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: redis-cluster
spec:
  selector:
    matchLabels:
      app: redis-cluster
  serviceName: redis-cluster-service-headless
  replicas: 6
  template:
    metadata:
      labels:
        app: redis-cluster
    spec:
      containers:
        - name: redis-cluster-node
          image: redis:7.2-rc2
          command:
            - redis-server
            - "/redis-master/redis.conf"
            - --requirepass "$(REDIS_PASSWORD)"
            - --masterauth "$(REDIS_PASSWORD)"
          env:
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: redis-config-secret
                  key: password
            - name: REDISCLI_AUTH
              valueFrom:
                secretKeyRef:
                  name: redis-config-secret
                  key: password
          ports:
            - containerPort: 6379
              name: client
              protocol: TCP
            - containerPort: 16379
              name: gossip
              protocol: TCP
          readinessProbe:
            exec:
              command:
              - sh
              - -c
              - /health/ping.local.sh
            initialDelaySeconds: 10
            timeoutSeconds: 5
          livenessProbe:
            exec:
              command:
              - sh
              - -c
              - /health/ping.local.sh
            initialDelaySeconds: 20
            timeoutSeconds: 5
          volumeMounts:
            - mountPath: /redis-master-data
              name: data
            - mountPath: /redis-master
              name: config
            - mountPath: /health
              name: health
      volumes:
        - name: data
          emptyDir: {}
        - name: config
          configMap:
            name: redis-cluster-config
            items:
              - key: redis-config
                path: redis.conf
        - name: health
          configMap:
            name: redis-cluster-config
            defaultMode: 0755
            items:
              - key: ping.local.sh
                path: ping.local.sh

